SystemOrganization addCategory: #CS528su13!
SystemOrganization addCategory: #'CS528su13-Payroll'!
SystemOrganization addCategory: #'CS528su13-ValueWithHistory'!

TestCase subclass: #EmployeeTestCase
	instanceVariableNames: 'susan day1 normalMonth aLittleOvertime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!EmployeeTestCase methodsFor: 'Running' stamp: 'dd 1/11/2005 19:36'!
setUp
	day1 := Date 
				newDay: 11
				month: 7
				year: 2001.
	susan := Employee new named: 'Susan'.
	normalMonth := #(#(40 0) #(40 0) #(40 0) #(40 0)).
	aLittleOvertime := #(#(40 0) #(50 0) #(40 0) #(40 0))
			! !

!EmployeeTestCase methodsFor: 'Testing' stamp: 'PengLiu 6/23/2013 08:44'!
testChangeSalary
	susan changeSalaryFor: day1 to: 20.
	self assert: (susan salaryAt: day1) = 20.
	day1 addDays: 7.
	susan changeSalaryFor: day1 to: 25.
	self assert: (susan salaryAt: day1) = 25
			! !

TestCase subclass: #PayrollSystemTestCase
	instanceVariableNames: 'myPayroll day1 susan george normalMonth aLittleOvertime john lastday amy adam'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!PayrollSystemTestCase methodsFor: 'Testing' stamp: 'PengLiu 6/27/2013 15:48'!
TestAddEmployee
	myPayroll addEmployee: susan.
	self assert: (myPayroll employeeNames includes: 'Susan').
	myPayroll addEmployee: george.
	self assert: (myPayroll employeeNamed: 'Susan') = susan
			! !

!PayrollSystemTestCase methodsFor: 'Testing' stamp: 'PengLiu 6/27/2013 15:49'!
TestLateTimeCard
"10/hour for July, 20/hour for August
post a timecard for July
test total earned is computed with salary for July
test total earned for the 2 months increases after July timecard is posed"

	| day2 todd endOfFirstMonth|
	day2 :=  Date newDay: 11 month: 8 year: 2001. 
	
	todd := Employee new named: 'Todd'.
	todd changeSalaryFor:  day1 to: 10.
	todd changeSalaryFor:  day2 to: 20.

	endOfFirstMonth := Date newDay: 10 month: 8 year: 2001.
	myPayroll
		addEmployee: todd.
	self postTimeCards: normalMonth to: todd  at: day2.
	self assert: (todd earnedAt: lastday) = 3200.
	self postTimeCards: aLittleOvertime to: todd at: day1.
	self assert: (todd earnedAt: endOfFirstMonth ) =1750.
	self assert: (todd earnedAt: lastday)  = 4950
! !

!PayrollSystemTestCase methodsFor: 'Testing' stamp: 'PengLiu 6/27/2013 15:49'!
TestMoreWithholdings
"amy with withholders Tax and Retirement
adam with witholders Tax and Insurance
test those are computed correctly accordingly"
	| payCheckForAmy payCheckForAdam |
	amy addWithHolder: #Retirement.
	adam addWithHolder: #Insurance.
	myPayroll
		addEmployee: adam;
		addEmployee: amy.
	self postTimeCards: normalMonth to: adam. 
	self postTimeCards: aLittleOvertime to: amy.
	payCheckForAmy := amy makePaycheckAt: lastday.
	self assert: (payCheckForAmy amountPaid  )  = (3500 - 909.5).
	payCheckForAdam := adam makePaycheckAt: lastday.
	self assert: (payCheckForAdam amountPaid)  = 2367.6.
			! !

!PayrollSystemTestCase methodsFor: 'Testing' stamp: 'PengLiu 6/27/2013 15:50'!
TestTakeHomePay
	myPayroll
		addEmployee: susan;
		addEmployee: george.
	self postTimeCards: normalMonth to: susan.
	self postTimeCards: aLittleOvertime to: george.
	self assert: (susan earnedAt: lastday)  = 3200.
	self assert: (george earnedAt: lastday)  = 2100
! !

!PayrollSystemTestCase methodsFor: 'homework' stamp: ''!
postTimeCards: collection to: anEmployee 
	| timecardDay |
	timecardDay := day1.
	collection do: 
			[:each | 
			anEmployee 
				postTimeCardFor: timecardDay
				hoursWorked: each first
				vacation: each last.
			timecardDay := timecardDay addDays: 7]
			! !

!PayrollSystemTestCase methodsFor: 'homework' stamp: 'PengLiu 6/23/2013 08:21'!
postTimeCards: collection to: anEmployee at: aDate
	| timecardDay |
	timecardDay := aDate.
	collection do: 
			[:each | 
			anEmployee 
				postTimeCardFor: timecardDay
				hoursWorked: each first
				vacation: each last.
			timecardDay := timecardDay addDays: 7]
			! !

!PayrollSystemTestCase methodsFor: 'homework' stamp: 'PengLiu 6/23/2013 11:24'!
setUp
	myPayroll := PayrollSystem new name: 'ACME'.
	day1 := Date newDay: 11 month: 7 year: 2001. 
	lastday := Date newDay: 11 month: 9 year: 2001.
	susan := Employee new named: 'Susan'.
	susan changeSalaryFor: day1 to: 20.
	george := Employee new named: 'George'.
	george changeSalaryFor: day1 to: 12.
	normalMonth := #(#(40 0) #(40 0) #(40 0) #(40 0)).
	aLittleOvertime := #(#(40 0) #(50 0) #(40 0) #(40 0)).
	john :=Employee new named: 'John'.
	amy := Employee new named: 'Amy'.
	amy changeSalaryFor:  day1 to: 20.

	adam := Employee new named: 'Adam'.
	adam changeSalaryFor:  day1 to: 20.
	! !

!PayrollSystemTestCase methodsFor: 'homework' stamp: 'PengLiu 6/27/2013 15:52'!
testTakeHomePayByDate
"change salary for the second month
test amountPaid in paycheck is computed correctly"
	| johns_check day0 day2 day3 day4 normalWeek |
	day0 := Date newDay: 1 month: 5 year: 1999.
	day2   := Date newDay: 5 month: 5 year: 1999. 
	day3  := Date newDay: 12 month: 5 year: 1999.
	day4 := Date newDay: 15 month: 5 year: 1999.
	john  := Employee new named: 'John'.
	john changeSalaryFor: day0 to: 20.
	john changeSalaryFor: day3 to: 40.
	normalWeek := #(#(40 0)).
	myPayroll
		addEmployee: john.
	self postTimeCards: normalWeek to: john at: day2.
	self postTimeCards: normalWeek to: john at: day3.
	johns_check := john makePaycheckAt: day4.
	
	myPayroll
		addEmployee: susan;
		addEmployee: george.
	self postTimeCards: normalMonth to: susan.
	self postTimeCards: aLittleOvertime to: george.
	"self assert: (johns_check amountPaid = 1783.2)."
	(PayrollSystemShell newOn: myPayroll) show! !

TestCase subclass: #SortedSequenceTestCase
	instanceVariableNames: 'sequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!SortedSequenceTestCase methodsFor: 'Running' stamp: ''!
setUp
	sequence := SortedSequence new.
	sequence add: 1; add: 80; add: 500; add: 501
			! !

!SortedSequenceTestCase methodsFor: 'Testing' stamp: ''!
testIndex
	"(SortedSequenceTestCase selector: #testIndex) run"

	self assert: (sequence indexOfStartOfIntervalContaining: 1) = 1.
	self assert: (sequence indexOfStartOfIntervalContaining: 79) = 1.
	self assert: (sequence indexOfStartOfIntervalContaining: 80) = 2.
	self assert: (sequence indexOfStartOfIntervalContaining: 501)	= 4
			! !

TestCase subclass: #ValueWithHistoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-ValueWithHistory'!

!ValueWithHistoryTest methodsFor: 'testing' stamp: 'm3r 6/27/2008 02:15'!
test
	| history day3 day2 day1 day4 |
	day3 := '12/12/2007' asDate.
	day2 := day3 subtractDays: 3.
	day1 := day2 subtractDays: 3.
	day4 :=  day3 addDays: 4.
	(history := ValueWithHistory new) starting: day3 become: 3.
	history starting: day1 become: 1.
	self should: [(history at: day2) = 1].
	history at: day2 add: 1.
	self should: [(history at: day3) = 4].
	history at: day4 add: 2.
	self should: [(history at: day4) = 6].
! !

SortedCollection variableSubclass: #SortedSequence
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!SortedSequence commentStamp: '<historical>' prior: 0!
I add one method to SortedCollection.  It would be just as easy to add the method
directly to the class instead of making a subclass, but this makes it easier to see
the new method.

The method is indexOfStartOfIntervalContaining: anElement
It returns the index of anElement or, if it is not present, the index of the
largest element smaller than it.  It is useful when you want to have a
table that is sorted by keys and you want to look up in the table to
find the nearest match to a key.!

!SortedSequence methodsFor: 'accessing' stamp: ''!
indexOfStartOfIntervalContaining: anElement 
	"Return the index of anElement or, if it is not present, of the index of the
	largest element smaller than it."

	self isEmpty ifTrue: [^0].
	^(self indexForInserting: anElement) - firstIndex
			! !

Object subclass: #Employee
	instanceVariableNames: 'name transactions salary earned paid withholding accruedVacation taxRule withholders withholdings'
	classVariableNames: 'HeadTaxRate MarriedSeparateTaxRate MarriedTaxRate SingleTaxRate WithholdingRules'
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!Employee commentStamp: '<historical>' prior: 0!
I represent an employee in a payroll system.  Thus, I keep track of the number of hours worked,
the wages paid, the vacation accrued, the taxes withheld, and so on.  My values change only
when transactions are posted to me.  Transactions are subclasses of EmployeeTransaction.

Variables
	name 				<String>
	transactions 			<Collection of Transactions, sorted by date>
	salary 				<ValueWithHistory>
	earned  				<ValueWithHistory>
	paid  				<ValueWithHistory>
	withholding  			<ValueWithHistory>
	accruedVacation  	<ValueWithHistory>
	taxRule 				<TaxRule>!

!Employee class methodsFor: 'class initialization' stamp: 'PengLiu 6/22/2013 23:18'!
initialize
	"Employee initialize"
	WithholdingRules := Dictionary new.

	SingleTaxRate := TaxRule new.
	SingleTaxRate
		breakPoint: 0 rate: 0.15;
		breakPoint: 22750 rate: 0.28;
		breakPoint: 55100 rate: 0.31;
		breakPoint: 115000 rate: 0.36;
		breakPoint: 250000 rate: 0.396.

	MarriedTaxRate := TaxRule new.
	MarriedTaxRate
		breakPoint: 0 rate: 0.15;
		breakPoint: 38000 rate: 0.28;
		breakPoint: 91850 rate: 0.31;
		breakPoint: 140000 rate: 0.36;
		breakPoint: 250000 rate: 0.396.

	MarriedSeparateTaxRate := TaxRule new.
	MarriedSeparateTaxRate
		breakPoint: 0 rate: 0.15;
		breakPoint: 19500 rate: 0.28;
		breakPoint: 45925 rate: 0.31;
		breakPoint: 70000 rate: 0.36;
		breakPoint: 125000 rate: 0.396.

	HeadTaxRate := TaxRule new.
	HeadTaxRate
		breakPoint: 0 rate: 0.15;
		breakPoint: 30500 rate: 0.28;
		breakPoint: 78700 rate: 0.31;
		breakPoint: 127500 rate: 0.36;
		breakPoint: 250000 rate: 0.396.

	WithholdingRules at: #Tax put: (TaxWithholder new).
	WithholdingRules at: #Insurance put: (InsuranceWithholder  new: 20).
	WithholdingRules at: #Retirement put: (RetirementDeposit new: 20).
! !

!Employee class methodsFor: 'homework' stamp: 'PengLiu 6/23/2013 07:45'!
withholder: aSymbol
	^WithholdingRules at: aSymbol ! !

!Employee methodsFor: 'homework' stamp: 'PengLiu 6/22/2013 22:01'!
addWithHolder: aSymbol
	withholders add: aSymbol ! !

!Employee methodsFor: 'actions' stamp: ''!
changeSalaryFor: aDate to: dollarPerHour 
	self postTransaction: (SalaryChange new
			date: aDate
			employee: self
			salary: dollarPerHour)
			! !

!Employee methodsFor: 'new' stamp: 'PengLiu 6/23/2013 08:00'!
earnedAt: aDate
	^earned at: aDate
			! !

!Employee methodsFor: 'private' stamp: ''!
federalTaxesOn: money assumingTotalIs: estimatedEarnings
	^money * (taxRule rateFor: estimatedEarnings)
			! !

!Employee methodsFor: 'new' stamp: 'PengLiu 6/23/2013 11:21'!
incrementEarned: anAmount at: aDate
	earned at: aDate add: anAmount .
	
	! !

!Employee methodsFor: 'new' stamp: 'PengLiu 6/23/2013 08:04'!
incrementPaid: anAmount at: aDate 
	paid at: aDate add: anAmount 
			! !

!Employee methodsFor: 'new' stamp: 'PengLiu 6/23/2013 08:04'!
incrementWithholding: anAmount at: aDate 
	withholding at: aDate add: anAmount 
			! !

!Employee methodsFor: 'homework' stamp: 'PengLiu 6/23/2013 10:46'!
makePaycheckAt: aDate 
	"Create a paycheck for the amount owed to the employee. It hasn't 
	been posted."

	| amountPaid amountWithheld withholdingDict |
	amountPaid := (self earnedAt: aDate) - (self paidAt: aDate) - (self withholdingAt: aDate).

	withholdingDict := Dictionary new.
	withholders do:  [ :each |
		withholdingDict at: each put: ((Employee withholder: each) withholdingOn: amountPaid for:self at:aDate ).
	].

	amountWithheld  := 0.
	withholdingDict keysDo:
		[ :each |
			amountWithheld := amountWithheld + withholdingDict at: each.
		 	withholdings at: each put: ((withholdings at: each ifAbsent: 0) + (withholdingDict at:each))
			 ].

	amountPaid := amountPaid - amountWithheld.
	^Paycheck newWithDate: aDate
		employee: self
		paid: amountPaid
		withheld: amountWithheld
		totalPaid: (self paidAt: aDate) + amountPaid
		totalWithheld: (self withholdingAt: aDate) + amountWithheld
		withholdings: withholdingDict 
! !

!Employee methodsFor: 'accessing' stamp: ''!
name
	^name
			! !

!Employee methodsFor: 'refactoring' stamp: 'PengLiu 6/23/2013 10:26'!
named: aString
	name := aString.
	transactions := OrderedCollection new.
	salary := ValueWithHistory zero.
	earned := ValueWithHistory zero.
 	paid := ValueWithHistory zero.
	withholding := ValueWithHistory zero.
	accruedVacation := 0.
	taxRule := SingleTaxRate.
	withholders  := Set new.
	withholders add: #Tax.
	withholdings := Dictionary new.
			! !

!Employee methodsFor: 'new' stamp: 'PengLiu 6/23/2013 08:05'!
paidAt: aDate 
	^paid at: aDate
			! !

!Employee methodsFor: 'actions' stamp: ''!
postTimeCardFor: aDate hoursWorked: hoursW vacation: hoursV 
	self postTransaction: (Timecard new
			date: aDate
			employee: self
			worked: hoursW
			vacation: hoursV)
			! !

!Employee methodsFor: 'posting' stamp: ''!
postTransaction: aTransaction
	"Public interface to record and process (i.e. post) a transaction."
	aTransaction postTo: self.
	transactions add: aTransaction
			! !

!Employee methodsFor: 'homework' stamp: 'PengLiu 6/22/2013 22:01'!
removeWithHolder: aSymbol
	withholders remove: aSymbol! !

!Employee methodsFor: 'new' stamp: 'PengLiu 6/23/2013 08:06'!
salary: anAmount at: aDate
	salary starting: aDate become: anAmount
			! !

!Employee methodsFor: 'new' stamp: 'PengLiu 6/23/2013 08:06'!
salaryAt: aDate
	^salary at: aDate
			! !

!Employee methodsFor: 'homework' stamp: 'PengLiu 6/23/2013 09:19'!
salaryHistoryOn: aStream
	| date |
	date := salary dateList.
	date do: [ :nextDate | 
		aStream nextPut: $(;
		print: nextDate;
		nextPut: $$;
		print: (salary at: nextDate);
		nextPut: $);
		cr ]! !

!Employee methodsFor: 'new' stamp: 'PengLiu 6/23/2013 08:34'!
withholdingAt: aDate
	^withholding at: aDate
			! !

Object subclass: #EmployeeTransaction
	instanceVariableNames: 'date employee'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!EmployeeTransaction commentStamp: '<historical>' prior: 0!
I'm an abstract class of transactions that can be posted to an Employee.

My most important method is postTo:, which is implemented by subclasses
to send a message to the Employee to post the transaction.  The Employee
has all the information, so it has to be the one to implement posting, but the
postTo: method implements a standard interface so that clients of the
payroll system can always post a transaction by sending the postTransaction:
message to an Employee.

Variables
	date		<Date>   Date at which transaction occured.
	employee	<Employee>

!

!EmployeeTransaction methodsFor: 'accessing' stamp: ''!
date
	^date
			! !

!EmployeeTransaction methodsFor: 'posting' stamp: ''!
post
	employee postTransaction: self
			! !

!EmployeeTransaction methodsFor: 'posting' stamp: ''!
postTo: anEmployee
	"double dispatching"
	self subclassResponsibility
			! !

EmployeeTransaction subclass: #Paycheck
	instanceVariableNames: 'amountPaid totalPaid withholdings thisTimeWithholdings totalWithholdings'
	classVariableNames: 'AmountFormat DateFormat'
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!Paycheck commentStamp: '<historical>' prior: 0!
Transaction representing a payment to an employee.!

!Paycheck class methodsFor: 'class initialization' stamp: 'dd 12/23/2004 18:15'!
initialize
	"Paycheck initialize"

	"AmountFormat := NumberPrintPolicy newFor: #usCurrency.
	DateFormat := TimestampPrintPolicy newFor: #us"
			! !

!Paycheck class methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/5/2013 18:16'!
newWithDate: aDate employee: anEmployee paid: amount1 withheld: amount2 totalPaid: amount3 totalWithheld: amount4
	| inst |
	inst := self new.
	inst date: aDate employee: anEmployee paid: amount1 withheld: amount2 totalPaid: amount3 totalWithheld: amount4.
	^inst! !

!Paycheck class methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/23/2013 10:23'!
newWithDate: aDate employee: anEmployee paid: amount1 withheld: amount2 totalPaid: amount3 totalWithheld: amount4 withholdings: w
	| inst |
	inst := self new.
	inst date: aDate employee: anEmployee paid: amount1 withheld: amount2 totalPaid: amount3 totalWithheld: amount4 withholdings: w.
	^inst! !

!Paycheck methodsFor: 'accessing' stamp: ''!
amountPaid
	^amountPaid
			! !

!Paycheck methodsFor: 'initialize-release' stamp: 'PengLiu 6/23/2013 10:43'!
date: aDate employee: anEmployee paid: amount1 withheld: amount2 totalPaid: amount3 totalWithheld: amount4
	date := aDate.
	employee := anEmployee.
	amountPaid := amount1.
	thisTimeWithholdings := amount2.
	totalPaid := amount3.
	totalWithholdings := amount4
			! !

!Paycheck methodsFor: 'initialize-release' stamp: 'PengLiu 6/23/2013 10:43'!
date: aDate employee: anEmployee paid: amount1 withheld: amount2 totalPaid: amount3 totalWithheld: amount4 withholdings: w
	date := aDate.
	employee := anEmployee.
	amountPaid := amount1.
	thisTimeWithholdings := amount2.
	totalPaid := amount3.
	totalWithholdings := amount4.
	withholdings := w.
			! !

!Paycheck methodsFor: 'refactoring' stamp: 'PengLiu 6/23/2013 10:42'!
postTo: anEmployee
	anEmployee incrementPaid: amountPaid at: date.
	anEmployee incrementWithholding: thisTimeWithholdings at: date.
			! !

!Paycheck methodsFor: 'printing' stamp: 'PengLiu 6/23/2013 10:43'!
printOnCheckStream: aStream
	"This method is supposed to print information on a check that is on the printer, and
	aStream is the printer.  Unfortunately, the whole method is bogus, because we don't
	know what the printer or the check are like.  I'm assuming that the check has two-parts.
	One is the actual check, and we need to print the employee's name and the amount.
	The second is the check stub, which will say how much is being paid and how much
 	is being withheld. I'm also assuming that the check is preprinted with the name of the
	company, and everything else that is usual for a check."

	aStream cr; cr.
	aStream next: 40 put: (Character space).
	"DateFormat print: date on: aStream."
	date printOn: aStream.
	aStream cr.
	aStream nextPutAll: ((String new: 40 withAll: Character space) copyReplaceFrom: 1 to: employee name size with: employee name).
	"AmountFormat print: amountPaid on: aStream."
	amountPaid printOn: aStream.
	aStream cr; cr; cr; cr.
	aStream nextPutAll: 'this month  '.
	"AmountFormat print: amountPaid on: aStream.
	AmountFormat print: taxes on: aStream."
	aStream nextPutAll: ' amountPaid: $'.
	amountPaid printOn: aStream.
	aStream nextPutAll: ' taxes: $'.
	thisTimeWithholdings printOn: aStream.
	aStream cr.
	aStream nextPutAll: 'year to date '.
	"AmountFormat print: totalPaid on: aStream.
	AmountFormat print: totalTaxes on: aStream."
	aStream nextPutAll: ' amountPaid: $'.
	totalPaid printOn: aStream.
	aStream nextPutAll: ' taxes: $'.
	totalWithholdings printOn: aStream.
	aStream cr; cr.
			! !

!Paycheck methodsFor: 'accessing' stamp: 'PengLiu 6/23/2013 10:42'!
taxes
	^thisTimeWithholdings
			! !

EmployeeTransaction subclass: #SalaryChange
	instanceVariableNames: 'newSalary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!SalaryChange commentStamp: '<historical>' prior: 0!
Transaction representing a change in salary, usually a raise.!

!SalaryChange methodsFor: 'accessing' stamp: 'PengLiu 6/27/2013 17:41'!
date: aDate
	date := aDate! !

!SalaryChange methodsFor: 'initialize-release' stamp: ''!
date: aDate employee: anEmployee salary: dollarPerHour
	date := aDate.
	employee := anEmployee.
	newSalary := dollarPerHour
			! !

!SalaryChange methodsFor: 'initialize-release' stamp: 'PengLiu 6/27/2013 17:41'!
employee: anEmployee salary: dollarPerHour
	employee := anEmployee.
	newSalary := dollarPerHour
			! !

!SalaryChange methodsFor: 'accessing' stamp: ''!
newSalary
	^newSalary
			! !

!SalaryChange methodsFor: 'refactoring' stamp: 'PengLiu 6/23/2013 08:29'!
postTo: anEmployee
	anEmployee salary: newSalary at: date
			! !

EmployeeTransaction subclass: #Timecard
	instanceVariableNames: 'hoursWorked hoursVacation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!Timecard commentStamp: '<historical>' prior: 0!
Transaction representing the work that the employee has done.!

!Timecard methodsFor: 'initialize-release' stamp: ''!
date: aDate employee: anEmployee worked: hoursW vacation: hoursV
	date := aDate.
	employee := anEmployee.
	hoursWorked := hoursW.
	hoursVacation := hoursV
			! !

!Timecard methodsFor: 'accessing' stamp: ''!
hoursVacation
	^hoursVacation
			! !

!Timecard methodsFor: 'accessing' stamp: ''!
hoursWorked
	^hoursWorked
			! !

!Timecard methodsFor: 'refactoring' stamp: 'PengLiu 6/23/2013 08:32'!
postTo: anEmployee 
	| money overtime nonovertime |
	overtime := hoursWorked - 40 max: 0.
	nonovertime := hoursWorked min: 40.
	money := overtime * 1.5 + nonovertime * (anEmployee salaryAt: date).
	anEmployee incrementEarned: money at: date
			! !

Object subclass: #PayrollSystem
	instanceVariableNames: 'employees paychecks companyName withholdRules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!PayrollSystem commentStamp: '<historical>' prior: 0!
I am the top-level of the payroll system.  I keep track of the employees
and can "run the payroll", i.e. write paychecks for the employees.  To
run the payroll, send the messages
	makePaychecksAt: paydate	- to create the paycheck transactions
	printPaychecksOn: aStream	- to print them out 
	postPaychecks				- to record them in employees

Note that the employees are not marked with having been paid until
the paychecks are posted, so just creating the transactions or even
printing them is not enough.

Variables
	employees   <Dictionary from String to Employee>
	paychecks 	<Collection of Paycheck>	holds paychecks that have been created until they have been posted!

!PayrollSystem class methodsFor: 'instance creation' stamp: ''!
new
	^super new initialize
			! !

!PayrollSystem methodsFor: 'accessing' stamp: ''!
addEmployee: anEmployee
	employees at: anEmployee name put: anEmployee
			! !

!PayrollSystem methodsFor: 'accessing' stamp: ''!
employeeNamed: aName
	^employees at: aName
			! !

!PayrollSystem methodsFor: 'accessing' stamp: ''!
employeeNames
	^employees keys asOrderedCollection
			! !

!PayrollSystem methodsFor: 'initialize-release' stamp: 'PengLiu 6/22/2013 23:12'!
initialize
	employees := Dictionary new.
! !

!PayrollSystem methodsFor: 'actions' stamp: ''!
makePaychecksAt: aDate 
	paychecks := employees collect: [:eachEmployee | eachEmployee makePaycheckAt: aDate]
			! !

!PayrollSystem methodsFor: 'accessing' stamp: ''!
name
	^companyName
			! !

!PayrollSystem methodsFor: 'accessing' stamp: ''!
name: aString
	companyName := aString
			! !

!PayrollSystem methodsFor: 'actions' stamp: ''!
paycheckString
	| aStream |
	aStream := WriteStream on: (String new: 20).
	self printPaychecksOn: aStream.
	^aStream contents
			! !

!PayrollSystem methodsFor: 'actions' stamp: ''!
postPaychecks
	paychecks do: [:each | each post].
	paychecks := #()
			! !

!PayrollSystem methodsFor: 'actions' stamp: ''!
printPaychecksOn: aStream 
	paychecks do: [:each | each printOnCheckStream: aStream]
			! !

Object subclass: #PayrollSystemShell
	instanceVariableNames: 'payrollSystem mainWindow employeelist employeeIndex employeeSelected dateModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!PayrollSystemShell commentStamp: '<historical>' prior: 0!
A PayrollSystemShell is the GUI of payroll system.
!

!PayrollSystemShell class methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/27/2013 13:53'!
newOn: aPayrollSystem
	| inst |
	inst := self new.
	inst setup: aPayrollSystem .
	^inst! !

!PayrollSystemShell methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/27/2013 19:55'!
changeSalary
	| newSalary transaction |
	newSalary := (UIManager default request: 'new salary is ?') asInteger.
	transaction := SalaryChange new.
	transaction employee: employeeSelected salary: newSalary.
	transaction date: dateModel date.
	transaction post.
	self changed: #salaryHistory! !

!PayrollSystemShell methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/27/2013 16:36'!
earnedHistoryIndex
	^0! !

!PayrollSystemShell methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/27/2013 16:36'!
earnedHistoryIndex: anInteger
	! !

!PayrollSystemShell methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/27/2013 16:37'!
earnedHistoryList
	! !

!PayrollSystemShell methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/27/2013 16:04'!
employeeAt: index
	^employeelist keys at: index! !

!PayrollSystemShell methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/27/2013 16:30'!
employeeSelected
	^employeeIndex ! !

!PayrollSystemShell methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/27/2013 17:09'!
employeeSelected: anInteger
	| names |
	employeeIndex := anInteger .
	names := payrollSystem employeeNames .
	employeeSelected := employeelist at: (names at: employeeIndex) .
	self changed: #employeeSelected .
	self changed: #salaryHistory .
	self contentsChanged ! !

!PayrollSystemShell methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/27/2013 15:59'!
employeelist
	^(employeelist keys)! !

!PayrollSystemShell methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/27/2013 16:59'!
salaryHistory
	| output |
	output := ReadWriteStream on: (String new).
	employeeSelected salaryHistoryOn: output.
	^output contents ! !

!PayrollSystemShell methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/27/2013 16:59'!
salaryHistory: text
	! !

!PayrollSystemShell methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/27/2013 17:50'!
setup: aPayrollSystem
	| employeelistMorph paidhistoryMorph earnedhistoryMorph names salaryMorph changeSalaryButton |
	payrollSystem := aPayrollSystem .
	mainWindow := SystemWindow labelled: aPayrollSystem name.
	
	employeeIndex := 1.
	
	employeelist := Dictionary new.
	names := aPayrollSystem employeeNames .
	names do: [ :eachname | employeelist at: eachname put: (aPayrollSystem employeeNamed: eachname)  ].
	
	employeeSelected := employeelist at: (names at: employeeIndex) .
		
	employeelistMorph := PluggableListMorph new.
	employeelistMorph on: self
		list: #employeelist
		selected: #employeeSelected
		changeSelected: #employeeSelected: 
		menu: nil
		keystroke: nil.
	mainWindow addMorph: employeelistMorph frame: (0 @ 0 corner: 0.5 @ 0.5).

	paidhistoryMorph := PluggableListMorph new.
	earnedhistoryMorph := PluggableListMorph new.
	salaryMorph := PluggableTextMorph new.
	
	salaryMorph on: self 
		text: #salaryHistory
		accept: #salaryHistory:
		readSelection: nil
		menu: nil.

	mainWindow addMorph: paidhistoryMorph frame:(0 @ 0.5 corner: 0.3 @ 1).
	mainWindow addMorph: earnedhistoryMorph frame:(0.3 @ 0.5 corner: 0.6 @ 1).
	mainWindow addMorph: salaryMorph frame:(0.6 @ 0.5 corner: 1 @ 1).
	
	changeSalaryButton := PluggableButtonMorph new.
	changeSalaryButton label: 'change salary'.
	
	changeSalaryButton on: self 
		getState: nil
		action: #changeSalary
		label: nil
		menu: nil.
		
	mainWindow addMorph: changeSalaryButton frame:(0.5 @ 0 corner: 1@ 0.1).
	! !

!PayrollSystemShell methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/27/2013 23:25'!
show	
	dateModel := DateModel new.
	dateModel openDialogWithSpec .
	"UIManager default openModal: mainWindow ."
	mainWindow openCenteredInWorld 

! !

Object subclass: #TaxRule
	instanceVariableNames: 'breakPoints rates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!TaxRule commentStamp: '<historical>' prior: 0!
I represent a tax table.  Given a yearly taxable income, I can give the tax rate for it.
I store the tax table as a sequence of amounts, and the tax rate for that amount.
For example, in 1994 the tax rate for a single person (schedule X) was
           $0		15%
  $22750	28%
  $55100	31%
$115000	36%
$250000	39.6%

breakpoints  	<SortedCollection of: integer>
rates	 	<OrderedCollection of: integer>!

!TaxRule class methodsFor: 'instance creation' stamp: ''!
new
	^super new initialize
			! !

!TaxRule methodsFor: 'accessing' stamp: ''!
breakPoint: aNumber rate: anotherNumber 
	"Add an entry to the tax table"

	| index |
	index := breakPoints indexOfStartOfIntervalContaining: aNumber.
	breakPoints add: aNumber.
	rates add: anotherNumber beforeIndex: index + 1
			! !

!TaxRule methodsFor: 'initialize-release' stamp: ''!
initialize
	breakPoints := SortedSequence new.
	rates := OrderedCollection new.
			! !

!TaxRule methodsFor: 'accessing' stamp: ''!
rateFor: aNumber 
	"Return the tax rate for someone whose taxable income is 
	aNumber dollars."

	^rates at: (breakPoints indexOfStartOfIntervalContaining: aNumber)
			! !

!TaxRule methodsFor: 'accessing' stamp: 'PengLiu 6/22/2013 22:17'!
withholdingOn: aCheck for: anEmployee at: aDate
	"Return the tax rate for someone whose taxable income is 
	aNumber dollars."
	^rates at: (breakPoints indexOfStartOfIntervalContaining: aCheck).
			! !

Object subclass: #ValueWithHistory
	instanceVariableNames: 'date value'
	classVariableNames: 'EarliestDate'
	poolDictionaries: ''
	category: 'CS528su13-ValueWithHistory'!

!ValueWithHistory commentStamp: 'm3r 6/27/2008 01:58' prior: 0!
I represent a (probably numerical) value that changes over time.  I can answer my value at any point in
time (usually a date).  I can update my value at any point in time, and also add a number to my
value from any point in time on into the future.  My value does not change continuously, but changes
at discrete points in time.

Instance Variables:
	date	<SortedCollection of: Date>
	value	<OrderedCollection of: Number>
	The i'th element of value matches the i'th element of date.  The date collection indicates when the value takes on the next element of the value collection.
!

!ValueWithHistory class methodsFor: 'class initialization' stamp: 'm3r 6/27/2008 02:05'!
initialize
	"self initialize"
	EarliestDate := Date newDay: 0 year: 0.
! !

!ValueWithHistory class methodsFor: 'instance creation' stamp: 'm3r 6/27/2008 02:06'!
new
	^ super new initialize
! !

!ValueWithHistory class methodsFor: 'instance creation' stamp: 'm3r 6/27/2008 02:06'!
zero
	^ self new starting: EarliestDate become: 0
! !

!ValueWithHistory methodsFor: 'accessing' stamp: 'm3r 6/27/2008 01:58'!
at: aDate 
	"Return value at aDate"
	| index |
	index := date indexOfStartOfIntervalContaining: aDate.
	index = 0 ifTrue: [self error: 'date is too early'].
	^value at: index
! !

!ValueWithHistory methodsFor: 'accessing' stamp: 'm3r 6/27/2008 01:59'!
at: aDate add: amount 
"Add amount to the value starting at aDate."
	| start |
	start := self indexForAccessing: aDate.
	start to: value size do:
		[:each | value at: each put: (value at: each) + amount].
! !

!ValueWithHistory methodsFor: 'homework' stamp: 'PengLiu 6/23/2013 09:17'!
dateList
	^date! !

!ValueWithHistory methodsFor: 'accessing' stamp: 'm3r 6/27/2008 02:00'!
indexForAccessing: aDate 
	"Create index of slot for aDate, creating it if necessary."
	| index |
	(index := date indexOfStartOfIntervalContaining: aDate) = 0 ifTrue: 
		[date add: aDate.
		value addFirst: 0.
		^ 1].
	(date at: index) = aDate ifTrue: [^index].
	date add: aDate.
	value add: (value at: index) beforeIndex: index + 1.
	^ index + 1
! !

!ValueWithHistory methodsFor: 'initialize-release' stamp: 'ChaseGeigle 6/15/2013 23:01'!
initialize
	date := SortedSequence new.
	value := OrderedCollection new.
! !

!ValueWithHistory methodsFor: 'printing' stamp: 'm3r 6/27/2008 02:03'!
printOn: aStream 
	date with: value do: 
		[: nextDate : nextValue | 
		aStream 
			nextPut: $(;
			print: nextDate;
			nextPutAll: ' -> ';
			print: nextValue;
			nextPut: $);
			cr].
! !

!ValueWithHistory methodsFor: 'homework' stamp: 'PengLiu 6/23/2013 11:18'!
starting: aDate add: anAmount 
	| index |
	date add: aDate.
	index := date indexOfStartOfIntervalContaining: aDate.
	value add: anAmount beforeIndex: index.
! !

!ValueWithHistory methodsFor: 'accessing' stamp: 'm3r 6/27/2008 02:00'!
starting: aDate become: anAmount 
	| index |
	date add: aDate.
	index := date indexOfStartOfIntervalContaining: aDate.
	value add: anAmount beforeIndex: index.
! !

Object subclass: #WithHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!WithHolder commentStamp: '<historical>' prior: 0!
A WithHolding is abstract class for all withholdings.
!

WithHolder subclass: #InsuranceWithholder
	instanceVariableNames: 'rate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!InsuranceWithholder commentStamp: '<historical>' prior: 0!
Each employee will have a fixed number of insurance withholding.!

!InsuranceWithholder class methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/22/2013 21:13'!
new: theRate
	^self new setRate: theRate
! !

!InsuranceWithholder methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/22/2013 21:15'!
setRate: theRate
	rate := theRate! !

!InsuranceWithholder methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/23/2013 07:50'!
withholdingOn: aCheck for: anEmployee at: aDate
	^10! !

WithHolder subclass: #RetirementDeposit
	instanceVariableNames: 'rate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!RetirementDeposit commentStamp: '<historical>' prior: 0!
Rule for withholding for retirement account.!

!RetirementDeposit class methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/22/2013 21:19'!
new: aNumber
	^self new setRate: aNumber! !

!RetirementDeposit methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/22/2013 21:18'!
setRate: aNumber
	rate := aNumber ! !

!RetirementDeposit methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/23/2013 07:51'!
withholdingOn: aCheck for: anEmployee at: aDate
	^10! !

WithHolder subclass: #TaxWithholder
	instanceVariableNames: 'rate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!TaxWithholder commentStamp: '<historical>' prior: 0!
Algorithm for tax computing!

!TaxWithholder methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/23/2013 08:35'!
withholdingOn: aCheck for: anEmployee at: aDate

	| socialSecurity federalTaxes stateTaxes estimatedEarnings earned |
	earned := anEmployee earnedAt: aDate .
	socialSecurity := (0 max: (aCheck min: 60600 - earned))
				* 0.077.
	estimatedEarnings := earned + aCheck * aDate day / aDate daysInYear.
	federalTaxes := anEmployee federalTaxesOn: aCheck assumingTotalIs: estimatedEarnings.
	stateTaxes := aCheck * 0.03.	"Illinois has a flat tax."
	^socialSecurity + federalTaxes + stateTaxes
			! !

!WithHolder methodsFor: 'as yet unclassified' stamp: 'PengLiu 6/22/2013 22:05'!
withholdingOn: aCheck for: anEmployee at: aDate
	self subclassResponsibility ! !
Employee initialize!
ValueWithHistory initialize!
Paycheck initialize!
